/*
 * read nmea sentence 2
 */

#include <LiquidCrystal.h>
#define LCD_LINES  2
#define LCD_CHARACTERS_PER_LINE  16
LiquidCrystal lcd(2,3,4,5,6,7);

#define LF  0x0a
#define CR  0x0d
String sentence;

#define WAITING  0
#define COLLECTING  1
#define DONE  2
int state;

void lcd_write_line(int line, String str)
{
  lcd.setCursor(0,line);
  for (int i=0; i<min(str.length(),LCD_CHARACTERS_PER_LINE); i++)
  {
    lcd.print(str[i]);
  }
}

void setup(void)
{
  lcd.begin(LCD_CHARACTERS_PER_LINE,LCD_LINES);
  Serial.begin(9600);
  state = WAITING;
}

void loop(void)
{
  if (Serial.available()>0)
  {
    char ch = Serial.read();
    //Serial.print(ch);
    if (ch=='$')
    {
      state = COLLECTING;
      sentence = "";
    }
    else if (ch==CR || ch==LF)
    {
      state = DONE;
    }
    if (state==COLLECTING)
    {
      sentence += ch;
    }
  }
  
  if (state==DONE)
  {
    // affiche 16 caracteres max sur la premiere ligne
    lcd_write_line(0,sentence);
    if (sentence.length()>LCD_CHARACTERS_PER_LINE)
    {
      // s'il reste des caracteres,
      // affiche 16 caracteres max sur la deuxieme ligne
      lcd_write_line(1,sentence.substring(LCD_CHARACTERS_PER_LINE));
    }
    state = WAITING;
  }
}

